<template>
  <div class="d-flex flex-column px-md-16 px-4 w-100">
    <div
      class="d-flex flex-sm-row flex-column align-center justify-space-between w-100 py-8"
    >
      <div class="d-flex flex-column">
        <h2>Benutzer verwalten</h2>
        <span>Hier kannst du Benutzer anlegen, verwalten und löschen.</span>
      </div>

      <div class="d-flex flex-row mt-sm-0 mt-8 ml-sm-4">
        <UserCreate @submitted="loadUsers()" />
      </div>
    </div>

    <div class="d-flex flex-column w-100">
      <v-card>
        <v-card-text>
          <v-table>
            <thead>
              <tr>
                <th class="text-left">Nachname, Vorname</th>
                <th class="d-sm-table-cell d-none text-left">E-Mail Adresse</th>
                <th class="d-md-table-cell d-none text-left">Rufnummer</th>
                <th class="d-md-table-cell d-none text-left">Rollen</th>
                <th class="text-center">Aktionen</th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="user in users" :key="user.id">
                <td>{{ user.lastName }}, {{ user.firstName }}</td>
                <td class="d-sm-table-cell d-none">
                  {{ user.email }}
                </td>
                <td class="d-md-table-cell d-none">
                  {{ user.phoneNumber || "Nicht bekannt.." }}
                </td>
                <td class="d-md-table-cell d-none">
                  <v-chip
                    density="comfortable"
                    size="small"
                    v-if="user.roles?.length === 0"
                  >
                    Keine Rolle..
                  </v-chip>

                  <v-chip
                    density="comfortable"
                    size="small"
                    v-for="role of user.roles"
                    :key="role.id"
                  >
                    {{ role.name }}
                  </v-chip>
                </td>
                <td class="d-flex justify-center align-center ga-2">
                  <UserPatch :user="user" @submitted="loadUsers()" />

                  <UserDelete :user="user" @submitted="loadUsers()" />
                </td>
              </tr>
            </tbody>
          </v-table>
        </v-card-text>
      </v-card>
    </div>
  </div>
</template>

<script lang="ts" setup>
import { onMounted, ref } from "vue";

import { api, UserResponse } from "../../api";
import UserDelete from "../../components/UserDelete.vue";
import UserPatch from "../../components/UserPatch.vue";

const users = ref<UserResponse[]>([]);

async function loadUsers(): Promise<void> {
  const { data, status, statusText } = await api.users.getAllUsers();

  if (status !== 200) {
    console.error(statusText);
    return;
  }
  users.value = data;
}

onMounted(loadUsers);
</script>
